package de.htwberlin.magw;


import de.htwberlin.magw.model.PatientInfo;
import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class AllergyActivity extends ListActivity {

	private static final String LOGTAG = "AllergyActivity";
//	private static final String[] ALLERGY = new String[] { "Nickel", "Amalgam", "Pollen",
//		"Nsse", "Hlsenfrchte", "noch was","noch was","noch was","noch was","noch was",
//		"und noch viel mehr"};

	@Override
	public void onCreate(Bundle savedInstanceState) {
		Log.d(LOGTAG, "OnCreate");
		super.onCreate(savedInstanceState);
		PatientInfo pi = PatientInfo.getInstance();
		if (pi.getUserId() != null && pi.getAllergien() != null) {
			String[] allergies = new String[pi.getAllergien().size()];
			pi.getAllergien().toArray(allergies);
			setListAdapter(new ArrayAdapter<String>(this, R.layout.allergy, allergies));
		}
		ListView listView = getListView();
		listView.setTextFilterEnabled(true);
		listView.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {
				// When clicked, show a toast with the TextView text
				Toast.makeText(getApplicationContext(),
						((TextView) view).getText(), Toast.LENGTH_SHORT).show();
			}
		});
	
	}

	@Override
	public void onRestart() {
		Log.d(LOGTAG, "OnRestart");
		super.onRestart();
	}
	
	@Override
	public void onResume() {
		Log.d(LOGTAG, "OnResume");
		super.onResume();
	}
	
	@Override
	public void onNewIntent(Intent intent) {
		Log.d(LOGTAG, "OnNewIntent: " + intent.getAction());
		super.onNewIntent(intent);
	}
}
