package de.htwberlin.magw;
import java.io.InputStream;
import java.net.URL;

import android.app.Activity;
import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.util.Log;
import android.widget.ImageView;
import android.widget.TextView;


public class DiagnosticReportActivity extends Activity {
	
	private static final String LOGTAG = "DiagnosticReportActivity";
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		Log.d(LOGTAG, "OnCreate");
		super.onCreate(savedInstanceState);
		setContentView(R.layout.history);
		Bundle extras = this.getIntent().getExtras();
		TextView title = (TextView)findViewById(R.id.dr_title);
		title.setText(extras.getString("TITLE"));
		TextView text = (TextView)findViewById(R.id.dr_text);
		text.setText(extras.getString("TEXT"));
		TextView date = (TextView)findViewById(R.id.dr_date);
		date.setText(extras.getString("DATE").substring(0, 10));
		ImageView imgView = (ImageView)findViewById(R.id.iv_picture);
		try {
        	imgView.setImageDrawable(grabImageFromUrl(extras.getString("IMAGE")));
        } catch(Exception e) {
        	
        }
	}

	@Override
	public void onRestart() {
		Log.d(LOGTAG, "OnRestart");
		super.onRestart();
	}
	
	@Override
	public void onResume() {
		Log.d(LOGTAG, "OnResume");
		super.onResume();
	}
	
	@Override
	public void onNewIntent(Intent intent) {
		Log.d(LOGTAG, "OnNewIntent: " + intent.getAction());
		super.onNewIntent(intent);
	}
	
	private Drawable grabImageFromUrl(String url) throws Exception {
    	return Drawable.createFromStream((InputStream)new URL(url).getContent(), "src");
    }
}
