package de.htwberlin.magw;

import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;

import de.htwberlin.magw.helper.JsonUrlLoader;
import de.htwberlin.magw.model.PatientInfo;

public class GeneralDataActivity extends Activity {

	private static final String LOGTAG = "GeneralDataActivity";
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Log.d(LOGTAG, "onCreate");
	    setContentView(R.layout.generaldata);
	    //this.setPatientData();
	}
	
	@Override
	public void onRestart() {
		super.onRestart();
		Log.d(LOGTAG, "OnRestart");
	}
	
	@Override
	public void onNewIntent(Intent intent) {
		super.onNewIntent(intent);
		Log.d(LOGTAG, "OnNewIntent");
		//this.setPatientData();
	}
	
	@Override
	public void onResume() {
		Log.d(LOGTAG, "OnResume");
		super.onResume();
		this.setPatientData();
		this.getBackendInfo();
	}
	
	private void setPatientData() {
//		TextView textview = new TextView(this);
//		textview.setText("Allgemeine Daten");
	PatientInfo patient = PatientInfo.getInstance();
	TextView lastname = (TextView) findViewById(R.id.lastname);
	lastname.setText(patient.getLastname());
	TextView name = (TextView) findViewById(R.id.forename);
	name.setText(patient.getName());
	TextView blood_group = (TextView) findViewById(R.id.bloodgroup);
	blood_group.setText(patient.getBloodgroup());
	TextView telephone = (TextView) findViewById(R.id.telephone);
	telephone.setText(patient.getTelephone());
	TextView insurance_id = (TextView) findViewById(R.id.insurance_id);
	insurance_id.setText(patient.getUserId());
	}
	
	private void getBackendInfo() {
		if (PatientInfo.getInstance().getUserId() != null) {
			//String url = "http://mgt.inka.f4.htw-berlin.de:5000/personen/323-42-0730/";
			String url = "http://mgt.inka.f4.htw-berlin.de:5000/personen/" + PatientInfo.getInstance().getUserId() + "/";
			JSONObject json = JsonUrlLoader.loadJsonFromUrl(url);
			if (json != null) {
				Log.d(LOGTAG, json.toString());
				try {
					String address = json.getString("adresse");
					String city = json.getString("ort");
					String zip = json.getString("plz");
					String birthday = json.getString("geburtstag");
					String sex = json.getString("geschlecht");
					String personal = json.getString("personal");
					
					TextView tv_address = (TextView) findViewById(R.id.his_address_str);
					tv_address.setText(address);
					TextView tv_city = (TextView) findViewById(R.id.his_address_city_zip);
					tv_city.setText(city + " / " + zip);
					TextView tv_birthday = (TextView) findViewById(R.id.his_birthday);
					tv_birthday.setText(birthday);
					TextView tv_sex = (TextView) findViewById(R.id.his_sex);
					tv_sex.setText(sex);
					TextView tv_personal = (TextView) findViewById(R.id.his_personal);
					tv_personal.setText(personal);
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} else {
				String na = getString(R.string.not_available);
				TextView tv_address = (TextView) findViewById(R.id.his_address_str);
				tv_address.setText(na);
				TextView tv_city = (TextView) findViewById(R.id.his_address_city_zip);
				tv_city.setText(na);
				TextView tv_birthday = (TextView) findViewById(R.id.his_birthday);
				tv_birthday.setText(na);
				TextView tv_sex = (TextView) findViewById(R.id.his_sex);
				tv_sex.setText(na);
				TextView tv_personal = (TextView) findViewById(R.id.his_personal);
				tv_personal.setText(na);
			}
		}
	}
}
