package de.htwberlin.magw;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.SortedSet;

import com.jjoe64.graphview.GraphView.GraphViewData;
import com.jjoe64.graphview.GraphView.GraphViewSeries;
import com.jjoe64.graphview.LineGraphView;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.widget.LinearLayout;
import de.htwberlin.magw.model.PatientInfo;
import de.htwberlin.magw.model.VitalDataSet;

public class GraphikActivity extends Activity {
	
	private static final String LOGTAG = "GraphikActivity";
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.graphik);
		//
		String sensor = null;
		String type = null;
		Bundle extras = getIntent().getExtras();
		if (extras == null) {
			return;
		}
		String value1 = extras.getString("sensor");
		String value2 = extras.getString("type");
		if (value1 != null) {
			// Do something with the data
			sensor = value1;
			type = value2;
		}
		Log.d("shithsit", type);

		this.drawGraphics(sensor, type);
	}

	@Override
	public void onRestart() {
		super.onRestart();
		Log.d(LOGTAG, "OnRestart");
	}
	
	@Override
	public void onNewIntent(Intent intent) {
		super.onNewIntent(intent);
		Log.d(LOGTAG, "OnNewIntent: " + intent.getAction());
		LinearLayout layout = (LinearLayout) findViewById(R.id.graph1);
		layout.removeAllViews();
		//layout.addView(graphView);
		
		String sensor = null;
		String type = null;
		Bundle extras = intent.getExtras();
		if (extras == null) {
			return;
		}
		String value1 = extras.getString("sensor");
		String value2 = extras.getString("type");
		if (value1 != null) {
			// Do something with the data
			sensor = value1;
			type = value2;
		}
		Log.d(LOGTAG, "OnNewIntent: type -> " + type);
		Log.d(LOGTAG, "OnNewIntent: sensor -> " + sensor);
		this.drawGraphics(sensor, type);
	}
	
	@Override
	public void onResume() {
		Log.d(LOGTAG, "OnResume");
		super.onResume();
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			VisualisierungActivity.group.back();
			return true;
		}
		return super.onKeyDown(keyCode, event);
	}
	
	private void drawGraphics(String sensor, String type){
		Log.d(LOGTAG, "drawGraphics: " + type);
		PatientInfo patient = PatientInfo.getInstance();

		SortedSet<VitalDataSet> vitalDataSet = null;
		if (sensor.equals("puls")) {
			sensor = "Puls";
			vitalDataSet = patient.getPulsVitalDataSet();
		} else if (sensor.equals("temperatur")) {
			sensor = "Temperatur";
			// todo get temepratur list

			vitalDataSet = patient.getTempVitalDataSet();
		}

		GraphViewData[] data = new GraphViewData[vitalDataSet.size()];
		int i = 0;
		for (VitalDataSet vitalDataSet2 : vitalDataSet) {

			data[i] = new GraphViewData(vitalDataSet2.getDate().getTime(),
					vitalDataSet2.getAvrValue());
			i++;
		}
		GraphViewSeries avrValues = new GraphViewSeries("Durchschnitts Werte",
				Color.rgb(200, 50, 00), data);

		data = new GraphViewData[vitalDataSet.size()];
		i = 0;
		for (VitalDataSet vitalDataSet2 : vitalDataSet) {

			data[i] = new GraphViewData(vitalDataSet2.getDate().getTime(),
					vitalDataSet2.getMaxValue());
			i++;
		}
		GraphViewSeries maxValues = new GraphViewSeries("Maximum Werte",
				Color.rgb(90, 250, 00), data);

		data = new GraphViewData[vitalDataSet.size()];
		i = 0;
		for (VitalDataSet vitalDataSet2 : vitalDataSet) {

			data[i] = new GraphViewData(vitalDataSet2.getDate().getTime(),
					vitalDataSet2.getMinValue());
			i++;
		}
		GraphViewSeries minValues = new GraphViewSeries("Minimal Werte", null,
				data);

		/*
		 * create graph
		 */

		SimpleDateFormat dateTimeFormatter = new SimpleDateFormat("dd:MM:yyyy");
		String datum = dateTimeFormatter.format(vitalDataSet.first().getDate());
		String titel = null;
		if (type.equals("all")) {
			titel = "Alle " + sensor + " Sensor Daten vom " + datum;
		} else if (type.equals("min")) {
			titel = "Minimal " + sensor + " Sensor Daten vom " + datum;
		} else if (type.equals("max")) {
			titel = "Maximal " + sensor + " Sensor Daten vom " + datum;
		} else if (type.equals("avr")) {
			titel = "Durchschnitt " + sensor + " Sensor Daten vom " + datum;
		}
		LineGraphView graphView = new LineGraphView(this, titel) {
			@Override
			protected String formatLabel(double value, boolean isValueX) {
				if (isValueX) {

					SimpleDateFormat dateTimeFormatter = new SimpleDateFormat(
							"hh:mm:ss");
					// convert unix time to human time
					return dateTimeFormatter.format(new Date((long) value));
				} else
					return super.formatLabel(value, isValueX); // let the
																// y-value be
																// normal-formatted
			}
		};
		// add data
		if (type.equals("all")) {
			graphView.addSeries(maxValues);
			graphView.addSeries(avrValues);
			graphView.addSeries(minValues);
		} else if (type.equals("min")) {
			graphView.addSeries(minValues);
		} else if (type.equals("max")) {
			graphView.addSeries(maxValues);
		} else if (type.equals("avr")) {
			graphView.addSeries(avrValues);
		}
		// optional - set view port, start=2, size=10
		long size = vitalDataSet.last().getDate().getTime()
				- vitalDataSet.first().getDate().getTime();
		graphView.setViewPort(vitalDataSet.first().getDate().getTime(), size);
		graphView.setScalable(true);
		// optional - legend
		graphView.setShowLegend(true);
		LinearLayout layout = (LinearLayout) findViewById(R.id.graph1);
		layout.addView(graphView);
	}
}
