package de.htwberlin.magw;

import java.util.SortedSet;

import de.htwberlin.magw.model.PatientInfo;
import de.htwberlin.magw.model.VitalDataSet;
import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

public class SensorAuswahlActivity extends ListActivity {

	private static final String LOGTAG = "SensorAuswahlActivity";
	private static final String[] SENSORTYPES = new String[] {"Puls Sensor Daten", "Temperatur Sensor Daten"};

	@Override
	public void onCreate(Bundle savedInstanceState) {
		Log.d(LOGTAG, "OnCreate");
		super.onCreate(savedInstanceState);	
		setListAdapter(new ArrayAdapter<String>(this, R.layout.allergy, SENSORTYPES));
		ListView listView = getListView();
		listView.setTextFilterEnabled(true);	
	}
	
	@Override
	protected void onListItemClick(ListView l, View v, int position, long id) {
		super.onListItemClick(l, v, position, id);
		Intent i = new Intent(this, SensorValueAusActivity.class);
		boolean startActivity=true;
		PatientInfo patient = PatientInfo.getInstance();
		if(position==0) {
			if(patient.getPulsVitalDataSet().isEmpty()){
				startActivity=false;
			}else{
				i.putExtra("sensor", "puls");
				Log.d(LOGTAG,"ist puls ");
			}
		} else if(position==1){
			if(patient.getTempVitalDataSet().isEmpty()){
				startActivity=false;
			}else{
				Log.d(LOGTAG,"ist temperatur");
				i.putExtra("sensor", "temperatur");
			}
		}
		if(startActivity){
			// Create the view using FirstGroup's LocalActivityManager
			View view = VisualisierungActivity.group.getLocalActivityManager()
							.startActivity("sensorvalueauswahl", i
							.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP)
							//.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP)
							).getDecorView();
			// Again, replace the view
			VisualisierungActivity.group.replaceView(view);
		}else{
	    	Toast notification = Toast.makeText(this, "Keine Vital Daten vom Sensor vorhanden", Toast.LENGTH_LONG);
			notification.show();
		}

	}	

	@Override
	public void onRestart() {
		Log.d(LOGTAG, "OnRestart");
		super.onRestart();
	}
	
	@Override
	public void onResume() {
		Log.d(LOGTAG, "OnResume");
		super.onResume();
	}
	
	@Override
	public void onNewIntent(Intent intent) {
		super.onNewIntent(intent);
		Log.d(LOGTAG, "OnNewIntent: " + intent.getAction());
	}	
}
