package de.htwberlin.magw;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class SensorValueAusActivity extends ListActivity {
	
	
	private static final String LOGTAG = "SensorValueAusActivity";
	private static final String[] VALUETYPE = new String[] {"Alle Werte in einer Grapik", "Minimal Werte", "Maximal Werte", "Durchschnitt Werte"};
	private static String SENSORTYPE;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		Log.d(LOGTAG, "OnCreate");
		super.onCreate(savedInstanceState);
		Bundle extras = getIntent().getExtras();
		if (extras == null) {
			return;
		}
		String value1 = extras.getString("sensor");
		if (value1 != null ) {
			// Do something with the data
			SENSORTYPE=value1;
		}
		setListAdapter(new ArrayAdapter<String>(this, R.layout.allergy, VALUETYPE));
		ListView listView = getListView();
		listView.setTextFilterEnabled(true);
		
	}
	
	@Override
	protected void onListItemClick(ListView l, View v, int position, long id) {
		super.onListItemClick(l, v, position, id);
		Intent i = new Intent(this, GraphikActivity.class);
		if (position==0) {
			//alle werte
			i.putExtra("sensor", SENSORTYPE);
			i.putExtra("type", "all");
		} else if(position==1){
			//min werte
			i.putExtra("sensor", SENSORTYPE);
			i.putExtra("type", "min");
		} else if(position==2){
			//max werte
			i.putExtra("sensor", SENSORTYPE);
			i.putExtra("type", "max");
		} else if(position==3){
			//avr werte
			i.putExtra("sensor", SENSORTYPE);
			i.putExtra("type", "avr");
		}
		// Create the view using FirstGroup's LocalActivityManager
		View view = VisualisierungActivity.group.getLocalActivityManager()
				.startActivity("grahikview", i
				.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP)
				//.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP)
				).getDecorView();
		// Again, replace the view
		VisualisierungActivity.group.replaceView(view);
	}

	@Override
	public void onRestart() {
		Log.d(LOGTAG, "OnRestart");
		super.onRestart();
	}
	
	@Override
	public void onResume() {
		Log.d(LOGTAG, "OnResume");
		super.onResume();
	}
	
	@Override
	public void onNewIntent(Intent intent) {
		Log.d(LOGTAG, "OnNewIntent: " + intent.getAction());
		super.onNewIntent(intent);
		Bundle extras = intent.getExtras();
		if (extras == null) {
			return;
		}
		String value1 = extras.getString("sensor");
		if (value1 != null ) {
			// Do something with the data
			Log.d(LOGTAG,extras.getString("sensor"));
			SENSORTYPE=value1;
		}
	}
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			VisualisierungActivity.group.back();
			return true;
		}
		return super.onKeyDown(keyCode, event);
	}
	

}
