package de.htwberlin.magw;

import java.util.ArrayList;

import android.app.ActivityGroup;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;

public class VisualisierungActivity extends ActivityGroup {

	public static final String LOGTAG = "VisualisierungsActivity";
    // Keep this in a static variable to make it accessible for all the nested activities, lets them manipulate the view
	public static VisualisierungActivity group;

    // Need to keep track of the history if you want the back-button to work properly, don't use this if your activities requires a lot of memory.
	private ArrayList<View> history;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		this.history = new ArrayList<View>();
		group = this;
		// Start the root activity withing the group and get its view
		View view = getLocalActivityManager().startActivity("ListSensorActivity", new
    	      							Intent(this,SensorAuswahlActivity.class)
										.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP)
										).getDecorView();

		// Replace the view of this ActivityGroup
		replaceView(view);
	}

	@Override
	public void onNewIntent(Intent intent) {
		Log.d(LOGTAG, "OnNewIntent: " + intent.getAction());
		super.onNewIntent(intent);
	}
	
	@Override
	public void onRestart() {
		Log.d(LOGTAG, "OnNRestart");
		super.onRestart();
	}
	
	@Override
	public void onResume() {
		Log.d(LOGTAG, "OnResume");
		super.onResume();
	}
	
	public void replaceView(View v) {
		// Adds the old one to history
		history.add(v);
		// Changes this Groups View to the new View.
		setContentView(v);
	}

	public void back() {
		Log.d(LOGTAG, "historylog: "+history.size());
		if(history.size() > 0) {
			history.remove(history.size()-1);
			setContentView((View) history.get(history.size()-1));
		}else {
			//finish();
		}
	}

	@Override
	public void onBackPressed() {
		VisualisierungActivity.group.back();
	    return;
	}
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			VisualisierungActivity.group.back();
			return true;
		}
			return super.onKeyDown(keyCode, event);
	}
}

