package de.htwberlin.magw;


import android.content.Intent;
import android.content.res.Resources;
import android.os.Bundle;
import android.util.Log;
import android.widget.TabHost;

public class VitaldatenActivity extends NfcPendingIntentTabActivity {

	private static final String LOGTAG = "VitaldatenActivity";
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		Log.d(LOGTAG, "onCreate");
		super.onCreate(savedInstanceState);
		setContentView(R.layout.vitaldaten);
		this.setTabIntents(false, true);
	}
	
	@Override
	public void onNewIntent(Intent intent) {
		Log.d(LOGTAG, "OnNewIntent: " + intent.getAction());
		super.onNewIntent(intent);
		if (intent.getAction() != null && intent.getAction().equalsIgnoreCase("android.nfc.action.TECH_DISCOVERED")) {
			//this.setTabIntents(true, true);
			this.showFirstTab();
		}
	}
	
	@Override
	public void onRestart() {
		Log.d(LOGTAG, "OnRestart");
		super.onRestart();
	}
	
	@Override
	public void onResume() {
		Log.d(LOGTAG, "OnResume");
		super.onResume();
		//setTabIntents(true, true);
	}
	
	private void setTabIntents(boolean reset, boolean showFirstTab) {
			
				Resources res = getResources(); // Resource object to get Drawables				
				TabHost tabHost = getTabHost(); // The activity TabHost
				if (reset == true) {
					tabHost.clearAllTabs();
				}
				
				TabHost.TabSpec spec; // Reusable TabSpec for each tab
				Intent intent; // Reusable Intent for each tab

				// Create an Intent to launch an Activity for GeneralData - TAB
				intent = new Intent().setClass(this, GeneralDataActivity.class);
				//intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);

				// Initialize a TabSpec for each tab and add it to the TabHost
				// 1. Tab for General Data
				spec = tabHost.newTabSpec("generaldata").setIndicator("Allgemein", 
						res.getDrawable(R.drawable.ic_tab_change_allgemein)).setContent(intent);
				tabHost.addTab(spec);

				// 2. Tab for Allergy
				intent = new Intent().setClass(this, AllergyActivity.class);
				//intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
				
				spec = tabHost.newTabSpec("allergy").setIndicator("Allergien",
						res.getDrawable(R.drawable.ic_tab_change_allergien)).setContent(intent);
				tabHost.addTab(spec);

				// 3. Tab for Medical History
				intent = new Intent().setClass(this, MedicalHistoryActivity.class);
				//intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
				
				spec = tabHost.newTabSpec("medicalhistory")
						.setIndicator("Krankengeschichte",
								res.getDrawable(R.drawable.ic_tab_change_history)).setContent(intent);
				tabHost.addTab(spec);

				// 4. Tab for Visualisierung
				intent = new Intent().setClass(this, VisualisierungActivity.class);
				//intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
				
				spec = tabHost.newTabSpec("visualisierung").setIndicator("Vitaldaten",
						res.getDrawable(R.drawable.ic_tab_change_grafik)).setContent(intent);
				tabHost.addTab(spec);

				if (showFirstTab == true) {
					this.showFirstTab();
				}
	}
	
	private void showFirstTab() {
		TabHost tabHost = getTabHost();
		tabHost.setCurrentTab(0);
	}
}
