package de.htwberlin.magw.helper;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

import org.json.JSONException;
import org.json.JSONObject;

import android.util.Log;

public class JsonUrlLoader {

	private static final String LOGTAG = "JsonUrlLoader";
	
	public static JSONObject loadJsonFromUrl(String url) {
		JSONObject json = null;
		URLConnection jsonUrl = null;
		InputStream in = null;
		String result = null;
		try {
			jsonUrl = new URL(url).openConnection();
		} catch (MalformedURLException e) {
			Log.d(LOGTAG, "MALFORMED URL EXCEPTION");
			return null;
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
		try {
			in = jsonUrl.getInputStream();
			result = convertStreamToString(in);
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		try {
			json = new JSONObject(result);
		} catch (JSONException e) {
			e.printStackTrace();
			return null;
		}
		return json;	
	}
	
	private static String convertStreamToString(InputStream is) throws UnsupportedEncodingException {
		BufferedReader reader = new BufferedReader(new InputStreamReader(is,"UTF-8"));
		StringBuilder sb = new StringBuilder();
		String line = null;
		try {
			while ((line = reader.readLine()) != null) {
				sb.append(line + "\n");
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				is.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return sb.toString();
	}
}
