package de.htwberlin.magw.model;

import java.util.SortedSet;


public class PatientInfo {
	private static PatientInfo _instance;
	private String userId;
	private String name;
	private String lastname;
	private String bloodgroup;
	private String telephone;
	private SortedSet<VitalDataSet> pulsVitalDataSet;
	private SortedSet<VitalDataSet> tempVitalDataSet;

	private SortedSet<String> allergien;

	private PatientInfo() {
		
	}
	
	public static PatientInfo getInstance() {
		if (_instance == null) {
			_instance = new PatientInfo();
		}
		return _instance;
	}
	

	
	public static PatientInfo getInstance(String userId) {
		if (_instance == null) {
			_instance = new PatientInfo();
		}
		if (userId != null) {
			_instance.setUserId(userId);
		}
		return _instance;
	}
	
	public void reset() {
		this.userId = null;
		this.name = null;
		this.lastname = null;
		this.bloodgroup = null;
		this.telephone = null;
		if (this.pulsVitalDataSet != null) {
			this.pulsVitalDataSet.clear();
		}
		this.pulsVitalDataSet = null;
		if (this.allergien != null) {
			this.allergien.clear();
		}
		this.allergien = null;
	}
	
	public void setUserId(String userId) {
		this.userId = userId;
	}
	
	public String getUserId() {
		return this.userId;
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getLastname() {
		return lastname;
	}

	public void setLastname(String lastname) {
		this.lastname = lastname;
	}

	public String getBloodgroup() {
		return bloodgroup;
	}

	public void setBloodgroup(String bloodgroup) {
		this.bloodgroup = bloodgroup;
	}
	public String getTelephone() {
		return telephone;
	}

	public void setTelephone(String telephone) {
		this.telephone = telephone;
	}

	public SortedSet<String> getAllergien() {
		return allergien;
	}

	public void setAllergien(SortedSet<String> allergien) {
		this.allergien = allergien;
	}

	public void setPulsVitalDataSet(SortedSet<VitalDataSet> vitalDataSet) {
		this.pulsVitalDataSet = vitalDataSet;
	}

	public SortedSet<VitalDataSet> getPulsVitalDataSet() {
		return pulsVitalDataSet;
	}
	public SortedSet<VitalDataSet> getTempVitalDataSet() {
		return tempVitalDataSet;
	}

	public void setTempVitalDataSet(SortedSet<VitalDataSet> tempVitalDataSet) {
		this.tempVitalDataSet = tempVitalDataSet;
	}
}
