// Sketch für das "verdammt schlaue Bett"
//
// author: Stephan Bergemann
// date: 25.10.2011
//

#include <stdint.h>
#include "AFMotor.h"
#include <stdlib.h>

#define PRECISION SINGLE

int kpos=0;
int fpos=0;

AF_Stepper kopfmotor(48,1);
AF_Stepper fussmotor(48,2);

void setup() {
  Serial.begin(9600);
  kopfmotor.setSpeed(20);
  fussmotor.setSpeed(20);
}

void setKopf(int npos) {
  if(npos>kpos) {
      kopfmotor.step(npos-kpos, FORWARD, PRECISION);
  } else if (npos<kpos) {
    kopfmotor.step(kpos-npos, BACKWARD, PRECISION);
  }
  kpos = npos;
}

void setFuss(int npos) {
  if(npos>fpos) {
    fussmotor.step(npos-fpos, BACKWARD, PRECISION);
  } else if (npos<fpos) {
    fussmotor.step(fpos-npos, FORWARD, PRECISION);
  }
  fpos = npos;
}
int i=0;
char commandbuffer[100];

void execute() {
  if(commandbuffer[0]=='k') {
    int npos = atoi(&(commandbuffer[1]));
    npos =    constrain(npos, 0, 50);
    setKopf(npos);
  } else if (commandbuffer[0]=='f') {
    int npos = atoi(&(commandbuffer[1]));
    npos = constrain(npos, 0, 50);
    setFuss(npos);
  }
  commandbuffer[0]='\0';
  i=0;
}

void loop() {
  if (Serial.available()) {
    while( Serial.available() && i< 99) {
      commandbuffer[i++] = Serial.read();
      Serial.write(commandbuffer[i-1]);
      if(commandbuffer[i-1]=='\r') {
        commandbuffer[i++]='\0';
        Serial.write("execute!");
        execute();
      }
    }
  }
}
