/*
 * TODO: <Classname> - <Description> 
 *
 * Copyright (c) 2011 Stephan Bergemann oberling@deroberling.de
 *
 * This file is part of TODO: <Projectname>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program (see COPYING); if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */


#include "bedmotorcommunicator.h"

BedMotorCommunicator::BedMotorCommunicator(QString port)
{
    _SerialDevice = new AbstractSerial();
    connect(_SerialDevice, SIGNAL(readyRead()), this, SLOT(readData()));
    _SerialDevice->setDeviceName(port);
    _SerialDevice->setBaudRate(AbstractSerial::BaudRate9600);
    if(!_SerialDevice->open(QIODevice::ReadWrite | QIODevice::Unbuffered)) {
        if(!_SerialDevice->open(QIODevice::ReadWrite | QIODevice::Unbuffered)) {
            QTextStream cerr(stderr, QIODevice::WriteOnly);
            cerr<<"Fehler: "<<_SerialDevice->errorString()<<endl;
        }
    }
}

BedMotorCommunicator::~BedMotorCommunicator() {
    _SerialDevice->close();
    delete _SerialDevice;
}

void BedMotorCommunicator::readData() {
    while(_SerialDevice->bytesAvailable()) {
        _data = _SerialDevice->readAll(); // einfach weg damit
    }
}

void BedMotorCommunicator::setHeadFeet(quint8 head, quint8 foot) {
    _head = head;
    _foot = foot;
    QByteArray headdata;
    headdata.append("k");
    headdata.append(QString::number(_head));
    headdata.append("\r");
    _SerialDevice->write(headdata);
    _SerialDevice->flush();
    QByteArray footdata;
    footdata.append("f");
    footdata.append(QString::number(_foot));
    footdata.append("\r");
    _SerialDevice->write(footdata);
    _SerialDevice->flush();
}
