/*
 * TODO: <Classname> - <Description> 
 *
 * Copyright (c) 2011 Stephan Bergemann oberling@deroberling.de
 *
 * This file is part of TODO: <Projectname>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program (see COPYING); if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */


#include "controller.h"
#include <QVector>

Controller::Controller()
{
    QTextStream cout(stdout, QIODevice::WriteOnly);
    cout<<"erstelle T31Communicator"<<endl;
    _t31 = new T31Communicator(1000);
    cout<<"erfolg!"<<endl;
    cout<<"erstelle TMP102Communicator"<<endl;
    _tmp102 = new TMP102Communicator(1000);
    cout<<"erfolg!"<<endl;
    cout<<"erstelle NFCCommunicator"<<endl;
    _nfc = new NFCCommunicator();
    cout<<"erfolg!"<<endl;
    cout<<"erstelle BettCommunicator"<<endl;
    _bed = new BedMotorCommunicator();
    cout<<"erfolg!"<<endl;
    _t31Timer = new QTimer();
    _t31Timer->setInterval(13*1000); // alle 5 Minuten auf NFC schreiben
    connect(_t31Timer, SIGNAL(timeout()), this, SLOT(t31WriteData()));
    _tmp102Timer = new QTimer();
    _tmp102Timer->setInterval(12*1000); // alle 5 Minuten auf NFC schreiben
    connect(_tmp102Timer, SIGNAL(timeout()), this, SLOT(tmp102WriteData()));
    _nfcTimer = new QTimer();
    _nfcTimer->setInterval(11*1000); // alle 5 Sekunden
    connect(_nfcTimer, SIGNAL(timeout()), this, SLOT(nfcGetTransponder()));
    _t31Timer->start();
    _tmp102Timer->start();
    _nfcTimer->start();
    _currentID = "";
}

void Controller::t31WriteData() {
    _nfc->writeData(_t31->getValues(), T31RECORD);
}

void Controller::tmp102WriteData() {
    _nfc->writeData(_tmp102->getValues(), TMP102RECORD);
}

void Controller::nfcGetTransponder() {
    QTextStream cout(stdout, QIODevice::WriteOnly);
    QVector<Transponder> transponders = _nfc->readTransponders();
    if(transponders.size()==1) {
        cout<<"hier bin ich!"<<endl<<flush;
        if(_currentID.compare(QString::fromStdString(transponders[0].getID()))!=0) {
            QVector<quint8> beddata = _nfc->getBedData();
            if(beddata.size()>0) {
                cout<<"Bettdaten: ";
            	_currentID = QString::fromStdString(transponders[0].getID());
                foreach(quint8 val, beddata)
                    cout<<" "<<val;
                cout<<endl;
                cout<<flush;
                _bed->setHeadFeet(beddata[0], beddata[1]);
            } else {
                cout<<"Bettdaten leer!"<<endl;
            }
        } else {
            cout<<"Daten bereits bekannt von ID "<<_currentID<<" bzw. "<<QString::fromStdString(transponders[0].getID())<<endl;
        }
    }
}
