/*
 * TODO: <Classname> - <Description> 
 *
 * Copyright (c) 2011 Stephan Bergemann oberling@deroberling.homelinux.org
 *
 * This file is part of TODO: <Projectname>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program (see COPYING); if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */


#ifndef CONTROLLER_H
#define CONTROLLER_H

#include "t31communicator.h"
#include "nfccommunicator.h"
#include "tmp102communicator.h"
#include "bedmotorcommunicator.h"
#include <QTimer>

#define T31RECORD 8
#define TMP102RECORD 9

class Controller : public QObject
{
    Q_OBJECT
public:
    Controller();
private slots:
    void t31WriteData();
    void tmp102WriteData();
    void nfcGetTransponder();
private:
    T31Communicator* _t31;
    NFCCommunicator* _nfc;
    TMP102Communicator* _tmp102;
    BedMotorCommunicator* _bed;

    QTimer* _t31Timer;
    QTimer* _tmp102Timer;
    QTimer* _nfcTimer;
    QString _currentID;
};

#endif // CONTROLLER_H
