/*
 * TODO: <Classname> - <Description> 
 *
 * Copyright (c) 2011 Stephan Bergemann oberling@deroberling.de
 *
 * This file is part of TODO: <Projectname>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program (see COPYING); if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */


#include "measuringinstrument.h"

MeasuringInstrument::MeasuringInstrument(QObject *parent) :
    QObject(parent)
{
    _enabled = true;
    _values = new QList<quint8>();
}

MeasuringInstrument::~MeasuringInstrument() {
    delete _values;
}

void MeasuringInstrument::addMeasurement(quint8 m) {
    _values->append(m);
}

void MeasuringInstrument::disable() {
    _enabled=false;
    _values->clear();
}

void MeasuringInstrument::setEnabled(bool enabled) {
    _enabled = enabled;
    if(!_enabled) _values->clear();
}

void MeasuringInstrument::enable() {
    _enabled=true;
}

QMap<QString, quint8> MeasuringInstrument::getValues() {
    QMap<QString, quint8> ret;
    quint8 min=255, max=0;
    float avg = 0.0;
    for(int i=0; i<_values->length(); i++) {
        avg += ((float)_values->at(i)/(float)_values->length());
        if(_values->at(i)<min)
            min = _values->at(i);
        if(_values->at(i)>max)
            max = _values->at(i);
    }
    _values->clear();
    ret["min"] = min;
    ret["max"] = max;
    ret["avg"] = (quint8) avg;
    return ret;
}
