/*
 * TODO: <Classname> - <Description> 
 *
 * Copyright (c) 2011 Stephan Bergemann oberling@deroberling.de
 *
 * This file is part of TODO: <Projectname>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program (see COPYING); if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */

#include <QTimer>
#include <abstractserial.h>
#include "measuringinstrument.h"

#ifndef T31COMMUNICATOR_H
#define T31COMMUNICATOR_H

#ifdef Q_WS_WIN
#define PORTNAME "COM1"
#elif defined Q_WS_MAC
#define PORTNAME "/dev/tty.usbserial-A40081Sx"
#else
#define PORTNAME "/dev/ttyUSB1"
#endif

class T31Communicator: public MeasuringInstrument
{
    Q_OBJECT
public:
    T31Communicator(quint16 pollIntervall, QString port=PORTNAME);
    ~T31Communicator();
private slots:
    void readData();
    void getSensorData();
private:
    AbstractSerial* _SerialDevice;
    QTimer* _t;
    QByteArray data;
};

#endif // T31COMMUNICATOR_H
