/*
 * TODO: <Classname> - <Description> 
 *
 * Copyright (c) 2011 Stephan Bergemann oberling@deroberling.de
 *
 * This file is part of TODO: <Projectname>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program (see COPYING); if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */


#include "tmp102communicator.h"

TMP102Communicator::TMP102Communicator(quint16 pollIntervall, QString port)
{
    _SerialDevice = new AbstractSerial();
    connect(_SerialDevice, SIGNAL(readyRead()), this, SLOT(readData()));
    _SerialDevice->setDeviceName(port);
    _SerialDevice->setBaudRate(AbstractSerial::BaudRate9600);
    if(!_SerialDevice->open(QIODevice::ReadWrite | QIODevice::Unbuffered)) {
        if(!_SerialDevice->open(QIODevice::ReadWrite | QIODevice::Unbuffered)) {
            QTextStream cerr(stderr, QIODevice::WriteOnly);
            cerr<<"Fehler: "<<_SerialDevice->errorString()<<endl;
        }
    }
    _t = new QTimer(this);
    _t->setInterval(pollIntervall);
    connect(_t, SIGNAL(timeout()), this, SLOT(getSensorData()));
    _t->start();
}

TMP102Communicator::~TMP102Communicator() {
    _t->stop();
    _SerialDevice->close();
    delete _t;
    delete _SerialDevice;
}

void TMP102Communicator::readData() {
    while(_SerialDevice->bytesAvailable()) {
        data = data+_SerialDevice->readLine();
        if(data.contains('\r')) {
            data.replace('\r', ' ');
            data = data.trimmed();
            QTextStream cout(stdout, QIODevice::WriteOnly);
            QList<QByteArray> list = data.split(' ');
            cout<<"temperatur: "<<list.last().toFloat()<<endl;
            addMeasurement((quint8) list.last().toFloat());
            data.remove(0, data.length());
        }
    }
}



void TMP102Communicator::getSensorData() {
    _SerialDevice->write(QByteArray("G\r\n"));
    _SerialDevice->flush();
}
