/*
 * TODO: <Classname> - <Description> 
 *
 * Copyright (c) 2011 Stephan Bergemann oberling@deroberling.de
 *
 * This file is part of TODO: <Projectname>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program (see COPYING); if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */

#include <QTimer>
#include <abstractserial.h>
#include "measuringinstrument.h"

#ifndef TMP102COMMUNICATOR_H
#define TMP102COMMUNICATOR_H

#ifdef Q_WS_WIN
#define TMP102PORTNAME "COM1"
#elif defined Q_WS_MAC
#define TMP102PORTNAME "/dev/tty.usbserial-A800eIfw"
#else
#define TMP102PORTNAME "/dev/ttyUSB0"
#endif

class TMP102Communicator: public MeasuringInstrument
{
    Q_OBJECT
public:
    TMP102Communicator(quint16 pollIntervall, QString port = TMP102PORTNAME);
    ~TMP102Communicator();
private slots:
    void readData();
    void getSensorData();
private:
    AbstractSerial* _SerialDevice;
    QTimer* _t;
    QByteArray data;
};

#endif // TMP102COMMUNICATOR_H
