/*
 * TODO: <Classname> - <Description> 
 *
 * Copyright (c) 2011 Stephan Bergemann oberling@deroberling.de
 *
 * This file is part of TODO: <Projectname>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program (see COPYING); if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */


#include "nfccommunicator.h"
#include "stdlib.h"
#include "nfcrfid/MifareDesfire.h"
#include "nfcrfid/NDEFRecord.h"
#include "nfcrfid/TextNDEFRecord.h"
#include "nfcrfid/NDEFMessage.h"
#include <QDateTime>

#include <QTextStream>
#include <QVector>

NFCCommunicator::NFCCommunicator()
{
    _NFCManager = new LibnfcDeviceManager();
    if(!_NFCManager->connect()) {
        QTextStream cerr(stderr, QIODevice::WriteOnly);
        cerr<<"kann nicht zu NFC verbinden"<<endl;
    }
}

void NFCCommunicator::writeData() {
    QTextStream cout(stdout, QIODevice::WriteOnly);
    std::vector<Transponder> stdtransponder = _NFCManager->readTransponders();
    cout<<"habe "<<stdtransponder.size()<<" transponder gesehen!"<<endl;
    if (stdtransponder.size() == 1 ){
        NDEFMessage message = _NFCManager->readNDEFMessage(&stdtransponder[0]);
        if(stdtransponder[0].getType() == DESFIRE_MIFARE) {
            std::vector<NDEFRecord*> records = message.getNdefRecords();
            if(records.size()!=0) {
                cout<<"habe folgendes gelesen: "<<endl;
                for(uint i=0; i<records.size(); i++) {
                    cout<<" "<<i<<": "<<records[i]->getNDEFRecordType()<<" "<<QString::fromStdString(records[i]->getPayload())<<endl;
                }
                cout<<"... doch nun kommen neue daten auf den transponder!"<<endl;
                records.clear();
                TextEnc e = UTF8;
                std::string lang("de");
                NDEFMessage* myMessage = new NDEFMessage();
                myMessage->addNdefRecord(new TextNDEFRecord(e, lang, std::string("P")));
                myMessage->addNdefRecord(new TextNDEFRecord(e, lang, std::string("test")));
                myMessage->addNdefRecord(new TextNDEFRecord(e, lang, std::string("123456")));
                myMessage->addNdefRecord(new TextNDEFRecord(e, lang, std::string("Pan, Peter")));
                myMessage->addNdefRecord(new TextNDEFRecord(e, lang, std::string("030 1234567")));
                myMessage->addNdefRecord(new TextNDEFRecord(e, lang, std::string("Allergie1, Allergie2, Allergie3, Allergie4")));
                myMessage->addNdefRecord(new TextNDEFRecord(e, lang, std::string("C++")));
                myMessage->addNdefRecord(new TextNDEFRecord(e, lang, std::string("10, a5")));
                myMessage->addNdefRecord(new TextNDEFRecord(e, lang, std::string("4f2d991a5960594f2d991b595a59")));
                myMessage->addNdefRecord(new TextNDEFRecord(e, lang, std::string("4f2d991a2426254f2d991b242625")));
                bool rueck = _NFCManager->writeNDEFMessage(&stdtransponder[0], myMessage);
                if(rueck) {
                    cout<<"alles ok!"<<endl;
                } else {
                    cout<<"irgendwas stimmt nicht..."<<endl;
                }
            } else {
                cout<<"Dieser Transponder enthält keine NDEF-Records!"<<endl;
            }
        } else {
            cout<<"Dieser Transponder ist kein DESFIRE-Transponder!"<<endl;
        }
    } else {
        cout<<"Bitte nur einen Transponder auf das Bett legen!"<<endl;
    }
}

