//
//  MainViewController.h
//  NFCKrankehausAnmeldung
//
//  Created by Maurus Rohrer on 1/16/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ReadCardViewController.h"
#import "AnmeldungViewController.h"
#import "LibnfcDeviceManager.h"



@interface MainViewController : NSViewController {
    
    IBOutlet NSButton *readCardButton;
    IBOutlet NSButton *anmeldungButton;
    IBOutlet NSTextField *errorMessage;
    
    IBOutlet NSView* readCardView;
    IBOutlet NSView* anmeldungView;
    IBOutlet NSView* errorView;
    
    
    
    ReadCardViewController * readCardViewController;
    AnmeldungViewController * anmeldungViewController;
    LibnfcDeviceManager *libnfcDevice;
    
    bool connected;
}
- (BOOL)wirteNDEFMessage:(NDEFMessage)mes;

- (IBAction)readNFCCard:(id)sender;
- (IBAction)anmelden:(id)sender;
- (IBAction)okBack:(id)sender;

@property (nonatomic, retain) ReadCardViewController * readCardViewController;
@property (nonatomic, retain) AnmeldungViewController * anmeldungViewController;
@property (assign) IBOutlet LibnfcDeviceManager *libnfcDevice;
@property (assign) IBOutlet NSTextField *errorMessage;
@property (nonatomic, retain) IBOutlet NSView* errorView;
@property (nonatomic, retain) IBOutlet NSView* anmeldungView;
@end
