//
//  MainViewController.m
//  NFCKrankehausAnmeldung
//
//  Created by Maurus Rohrer on 1/16/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import "MainViewController.h"
#import "ReadCardViewController.h"

#import <vector>

@implementation MainViewController
@synthesize readCardViewController, libnfcDevice, errorView, errorMessage,anmeldungView,anmeldungViewController;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Initialization code here.
    }
    
    libnfcDevice =  new LibnfcDeviceManager();
    if(libnfcDevice->connect()){
        NSLog(@"ja mann ist verbunden");
        connected =true;
    }else{
        NSLog(@"connect failed");
        connected=false;
    }
    return self;
}

- (void)dealloc
{
    [super dealloc];
}


- (IBAction)readNFCCard:(id)sender{
    
    //make hack left screen ok
//    readCardViewController = [[ReadCardViewController alloc] initWithNibName:@"ReadCardViewController" bundle:nil];
//    NSView * cardview = [readCardViewController view];
//    [cardview enterFullScreenMode:[NSScreen mainScreen] withOptions:nil];
//    [cardview exitFullScreenModeWithOptions:nil];
    NSDictionary *options = [NSDictionary dictionaryWithObjectsAndKeys:
                             [NSNumber numberWithBool:YES], NSFullScreenModeAllScreens,
                             [NSNumber numberWithUnsignedInt:(unsigned)(// NSApplicationPresentationDefault|
                                                                        // NSApplicationPresentationAutoHideDock|
                                                                        NSApplicationPresentationHideDock|
                                                                        NSApplicationPresentationAutoHideMenuBar|
                                                                        // NSApplicationPresentationDisableAppleMenu|
                                                                        // NSApplicationPresentationDisableProcessSwitching|
                                                                        NSApplicationPresentationDisableSessionTermination|
                                                                        NSApplicationPresentationDisableHideApplication|
                                                                        NSApplicationPresentationDisableMenuBarTransparency
                                                                        )],
                             NSFullScreenModeApplicationPresentationOptions,
                             nil];
    
    NSLog(@"readnfc card button pressed");    
    if(connected) {
        
        std::vector<Transponder>  test = libnfcDevice->readTransponders();
        if(test.empty()){
            

            NSLog(@"keine karte am reader");
            [errorMessage setStringValue:@"Keine Karte am Reader \n, Bitte Karte hinhalten. "];
           
           // [self.view removeFromSuperview];
             [self.view addSubview:errorView ];
             
            [errorView enterFullScreenMode:[NSScreen mainScreen] withOptions:options];
        } else if(test.size()>1){
            NSLog(@"bitte nur eine karte an reader");
            [errorMessage setStringValue:@"Bitte nur eine karte an reader! "];
            [self.view addSubview:errorView ];
            
            [errorView enterFullScreenMode:[NSScreen mainScreen] withOptions:options];
        } else{
            NSLog(@"super eine ka1rte am reader");
            if(test[0].getType() != DESFIRE_MIFARE){
                NSLog(@"falsche karte am reader");
                [errorMessage setStringValue:@"Karte kann nicht gelesen werden! "];
                [self.view addSubview:errorView ];
                
                [errorView enterFullScreenMode:[NSScreen mainScreen] withOptions:options];
            }else{
                NDEFMessage message= libnfcDevice->readNDEFMessage(&test[0]);
                std::vector<NDEFRecord*> records = message.getNdefRecords();
                       
                if (records.size()==10) {
                    readCardViewController = [[ReadCardViewController alloc] initWithNibName:@"ReadCardViewController" bundle:nil];
                    NSView * cardview = [readCardViewController view];
                    [self.view addSubview:cardview ];
                    [cardview enterFullScreenMode:[NSScreen mainScreen] withOptions:options];
                    [readCardViewController setRecordValues:records];
                }else{
                    NSLog(@"falsche karte am reader");
                    [errorMessage setStringValue:@"Keine Krankenhaus Karte am Reader! "];
                    [self.view addSubview:errorView ];
                    
                    [errorView enterFullScreenMode:[NSScreen mainScreen] withOptions:options];
                }
                
            }

        }
        
	} else{
        NSLog(@"reader not connected");
    }

    
    
}


- (IBAction)anmelden:(id)sender{
    
    if (connected) {
        NSDictionary *options = [NSDictionary dictionaryWithObjectsAndKeys:
                                 [NSNumber numberWithBool:YES], NSFullScreenModeAllScreens,
                                 [NSNumber numberWithUnsignedInt:(unsigned)(// NSApplicationPresentationDefault|
                                                                            // NSApplicationPresentationAutoHideDock|
                                                                            NSApplicationPresentationHideDock|
                                                                            NSApplicationPresentationAutoHideMenuBar|
                                                                            // NSApplicationPresentationDisableAppleMenu|
                                                                            // NSApplicationPresentationDisableProcessSwitching|
                                                                            NSApplicationPresentationDisableSessionTermination|
                                                                            NSApplicationPresentationDisableHideApplication|
                                                                            NSApplicationPresentationDisableMenuBarTransparency
                                                                            )],
                                 NSFullScreenModeApplicationPresentationOptions,
                                 nil];
        anmeldungViewController = [[AnmeldungViewController alloc] initWithNibName:@"AnmeldungViewController" bundle:nil];
        NSView * anmeldungsView = [anmeldungViewController view];
        [self.view addSubview:anmeldungsView ];
        [anmeldungsView enterFullScreenMode:[NSScreen mainScreen] withOptions:options];
        [anmeldungViewController initAfterload:libnfcDevice];
        
       
    }
   

    
}

- (IBAction)okBack:(id)sender{
    [errorView exitFullScreenModeWithOptions:nil];
    [errorView removeFromSuperview];
    
}

- (BOOL)wirteNDEFMessage:(NDEFMessage)mes{
    
}
@end
