#!/usr/bin/env python
# -*- coding: utf-8 -*-

from flaskext.script import Manager, Server
from server import app, db
from model import Person, Befund, Allergie

import datetime

manager = Manager(app)
manager.add_command("runserver", Server(host="0.0.0.0"))

@manager.command
def initdb():
    """Creates all database tables."""
    db.create_all()

    b1 = Befund()
    b1.titel = u"Blinddarm"
    b1.bild = u"http://i.imgur.com/pHsIr.jpg"
    b1.datum = datetime.datetime(2011, 12, 1)
    b1.text = u"""Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet."""
    db.session.add(b1)

    b2 = Befund()
    b2.titel = u"Krebs"
    b2.bild = u"http://i.imgur.com/1oBW1.jpg"
    b2.datum = datetime.datetime(1999, 4, 12)
    b2.text = u"""Überall dieselbe alte Leier. Das Layout ist fertig, der Text lässt auf sich warten. Damit das Layout nun nicht nackt im Raume steht und sich klein und leer vorkommt, springe ich ein: der Blindtext. Genau zu diesem Zwecke erschaffen, immer im Schatten meines großen Bruders »Lorem Ipsum«, freue ich mich jedes Mal, wenn Sie ein paar Zeilen lesen. Denn esse est percipi - Sein ist wahrgenommen werden. Und weil Sie nun schon die Güte haben, mich ein paar weitere Sätze lang zu begleiten, möchte ich diese Gelegenheit nutzen, Ihnen nicht nur als Lückenfüller zu dienen, sondern auf etwas hinzuweisen, das es ebenso verdient wahrgenommen zu werden: Webstandards nämlich."""
    db.session.add(b2)

    b3 = Befund()
    b3.titel = u"Grippe"
    b3.datum = datetime.datetime(2012, 1, 3)
    b3.text = u"""Er hörte leise Schritte hinter sich. Das bedeutete nichts Gutes. Wer würde ihm schon folgen, spät in der Nacht und dazu noch in dieser engen Gasse mitten im übel beleumundeten Hafenviertel? Gerade jetzt, wo er das Ding seines Lebens gedreht hatte und mit der Beute verschwinden wollte! Hatte einer seiner zahllosen Kollegen dieselbe Idee gehabt, ihn beobachtet und abgewartet, um ihn nun um die Früchte seiner Arbeit zu erleichtern? Oder gehörten die Schritte hinter ihm zu einem der unzähligen Gesetzeshüter dieser Stadt, und die stählerne Acht um seine Handgelenke würde gleich zuschnappen? Er konnte die Aufforderung stehen zu bleiben schon hören. Gehetzt sah er sich um."""
    db.session.add(b3)

    a1 = Allergie(u"Nickel")
    a2 = Allergie(u"Latex")
    a3 = Allergie(u"Blütenpollen")
    a4 = Allergie(u"Tierhaare")
    db.session.add_all([a1, a2, a3, a4,
        Allergie(u"Hausstaubmilben"),
        Allergie(u"Nahrungsmittel"),
        Allergie(u"Arzneimittel"),
        Allergie(u"Schimmelpilz")])

    p1 = Person()
    p1.vorname = u"Matthias"
    p1.nachname = u"Frankfurter"
    p1.geschlecht = u"männlich"
    p1.geburtstag = datetime.datetime(1943, 4, 19)
    p1.notfallnummer = u"0711 55 00 47"
    p1.adresse = u"Ollenhauer Str. 67"
    p1.plz = u"70435"
    p1.ort = u"Stuttgart Rot"
    p1.kknummer = u"323-42-0730"
    p1.passwort = u"gott"
    p1.personal = False
    p1.befunde = [b2, b3]
    p1.allergien = [a1, a2, a3]
    p1.blutgruppe = "AB"
    db.session.add(p1)

    p2 = Person()
    p2.vorname = u"Klaudia"
    p2.nachname = u"König"
    p2.geschlecht = u"weiblich"
    p2.geburtstag = datetime.datetime(1985, 8, 24)
    p2.notfallnummer = u"06430 75 62 64"
    p2.adresse = u"Hollander Strasse 9"
    p2.plz = u"65623"
    p2.ort = u"Schiesheim"
    p2.kknummer = u"595-36-6079"
    p2.passwort = u"liebe"
    p2.personal = True
    p2.befunde = [b1]
    p2.allergien = [a1, a2, a4]
    p2.blutgruppe = "0"
    db.session.add(p2)

    db.session.commit()

@manager.command
def dropdb():
    """Drops all database tables."""
    db.drop_all()

if __name__ == '__main__':
    manager.run()
