#!/usr/bin/env python
# -*- coding: utf-8 -*-

from server import db

allergien = db.Table('allergien',
    db.Column('allergien_name', db.String(255), db.ForeignKey('allergie.name')),
    db.Column('person_kknummer', db.String(255), db.ForeignKey('person.kknummer'))
)

class Person(db.Model):
    #id = db.Column(db.Integer, primary_key=True)
    kknummer = db.Column(db.String(255), primary_key=True)
    vorname = db.Column(db.String(255))
    nachname = db.Column(db.String(255))
    geschlecht = db.Column(db.Enum(u"männlich", u"weiblich"))
    geburtstag = db.Column(db.DateTime)
    notfallnummer = db.Column(db.String(255))
    adresse = db.Column(db.String(255))
    plz = db.Column(db.String(255))
    ort = db.Column(db.String(255))
    passwort = db.Column(db.String(255))
    personal = db.Column(db.Boolean)
    blutgruppe = db.Column(db.String(255))

    befunde = db.relationship('Befund', backref='person',
        lazy='dynamic')
    allergien = db.relationship('Allergie', secondary=allergien, backref='personen',
        lazy='dynamic')

    def __repr__(self):
        return '<Person %r %r>' % (self.vorname, self.nachname)

class Befund(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    titel = db.Column(db.String(255))
    bild = db.Column(db.String(255))
    datum = db.Column(db.DateTime)
    text = db.Column(db.Text)

    person_kknummer = db.Column(db.String(255), db.ForeignKey('person.kknummer'))

    def __repr__(self):
        return '<Befund %r>' % self.titel

class Allergie(db.Model):
    name = db.Column(db.String(255), primary_key=True)

    def __init__(self, name):
        self.name = name

    def __repr__(self):
        return '<Allergie %r>' % self.name
