#!/usr/bin/env python
# -*- coding: utf-8 -*-

from flask import Flask
from flask import render_template
from flaskext.sqlalchemy import SQLAlchemy

app = Flask(__name__)
app.config['SQLALCHEMY_DATABASE_URI'] = 'sqlite:////tmp/test.db'
db = SQLAlchemy(app)

from controller import PersonController, BefundController, AllergieController

def register_api(view, url, endpoint, pk='id', pk_type='int'):
    view_func = view.as_view(endpoint)
    app.add_url_rule(url, defaults={pk: None},
                     view_func=view_func, methods=['GET',])
    app.add_url_rule(url, view_func=view_func, methods=['POST',])
    app.add_url_rule('%s<%s:%s>' % (url, pk_type, pk), view_func=view_func,
                     methods=['GET', 'PUT', 'DELETE'])
    app.add_url_rule('%s<%s:%s>/' % (url, pk_type, pk), view_func=view_func,
                     methods=['GET', 'PUT', 'DELETE'])

@app.route('/')
def index():
    return render_template("index.html")

register_api(PersonController, '/personen/', 'person_api', pk='kknummer', pk_type='default')
register_api(BefundController, '/befunde/', 'befund_api', pk='befund_id')
register_api(AllergieController, '/allergien/', 'allergie_api', pk='name', pk_type='default')
