//Copyright 2011 INKA - HTW Berlin
//
//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
//  Created by Maurus Rohrer maurus.rohrer@gmail.com


#ifndef NDEFMessage_
#define NDEFMessage_


#include <vector>
#include <iostream>
#include <sstream>
#include <iomanip> 
#include "NDEFRecord.h"

#include "UriNDEFRecord.h"
#include "TextNDEFRecord.h"

class NDEFMessage {
    public:
        NDEFMessage();
        NDEFMessage(NDEFRecord*);
        std::vector<NDEFRecord*> getNdefRecords();
        bool addNdefRecord(NDEFRecord*);
        std::string getTLV();
        std::string getNDEFMessage();
        static NDEFMessage parseNDEFMessage(std::string);
    
        int getNDEFMessageLength();
        std::string getNDEFMessageLengthHex();
    private:
        std::string byteToHexString(unsigned char);
        std::string charStringToHexString(std::string str);
        std::string hexStringToCharString(std::string str);
        std::vector<NDEFRecord*> ndefRecords;
    
};

#endif