//Copyright 2011 INKA - HTW Berlin
//
//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
//  Created by Maurus Rohrer maurus.rohrer@gmail.com



#ifndef NDEFRecord_
#define NDEFRecord_


#include <string>
#include <iostream>
#include <sstream>
#include <iomanip> 


enum NDEFRecordType {
    URI=0x55,
    TEXT=0x54
    };

class NDEFRecord {
public:
    NDEFRecord(NDEFRecordType, std::string);
    //int getLength();
    virtual NDEFRecordType getNDEFRecordType()=0;
    virtual std::string getPayload()=0;
    virtual std::string getPayloadHex()=0;
    virtual std::string getNDEFRecordHeader()=0;
    static NDEFRecord* parseNdefRecord(std::string, bool);
    void setPayload(std::string);
protected:
    NDEFRecordType type;
    //int length;
    std::string identifier;
    std::string payload;
    
    std::string byteToHexString(unsigned char);
    std::string charStringToHexString(std::string* str);

};

#endif