//Copyright 2011 INKA - HTW Berlin
//
//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
//  Created by Maurus Rohrer maurus.rohrer@gmail.com

#ifndef RFDeviceManager_
#define RFDeviceManager_

#include <vector>
#include "Transponder.h"
#include "NDEFMessage.h"
/* The classes below are exported */
#pragma GCC visibility push(default)

class RFDeviceManager
{
	public:
		virtual bool connect()=0;
        virtual bool disconnect()=0;
        virtual std::vector<Transponder> readTransponders()=0;
        virtual bool isNDEFConform(Transponder*)=0;
        virtual bool makeNDEFConform(Transponder*)=0;
        virtual bool writeNDEFMessage(Transponder*,NDEFMessage*)=0;
        virtual NDEFMessage readNDEFMessage(Transponder*)=0;
        
};

#pragma GCC visibility pop
#endif
