//Copyright 2011 INKA - HTW Berlin
//
//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
//  Created by Maurus Rohrer maurus.rohrer@gmail.com



#ifndef TextNDEFRecord_
#define TextNDEFRecord_


#include "NDEFRecord.h"
#include <string>


enum TextEnc {
    UTF8,
    UTF16
    };

 
class TextNDEFRecord : public NDEFRecord {
    public:
        TextNDEFRecord(TextEnc, std::string, std::string);
        TextEnc getEncoding();
        std::string getLanguage();
    
        NDEFRecordType getNDEFRecordType();
        std::string getPayload();
        std::string getPayloadHex();
        std::string getNDEFRecordHeader();
        static TextNDEFRecord* parseTextNDEFRecord(std::string,bool);
    
    private:
    TextEnc encoding;
    std::string language;
};

#endif