//Copyright 2011 INKA - HTW Berlin
//
//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
//  Created by Maurus Rohrer maurus.rohrer@gmail.com
//

#ifndef Transponder_
#define Transponder_

#include <string>
#include <ostream>
#include <freefare.h>


enum TransponderType {
    ULTRALIGHT_MIFARE,
    ULTRALIGHT_C_MIFARE,
    CLASSIC_1K_MIFARE,
    CLASSIC_4K_MIFARE,
    DESFIRE_MIFARE,
    ICODE,
    UNKNOWN
};

class Transponder
{
    friend std::ostream& operator<<(std::ostream& output, const Transponder& t);
public:
    Transponder(std::string="0");
    void setID(std::string);
    std::string getID();
    void setSize(int);
    int getSize();
    TransponderType getType();
protected:
    std::string ID;
    TransponderType type;
    int size;

};

#endif
