//Copyright 2011 INKA - HTW Berlin
//
//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
//  Created by Maurus Rohrer maurus.rohrer@gmail.com

#ifndef UriNDEFRecord_
#define UriNDEFRecord_

#include "NDEFRecord.h"

enum UriType {
    UNSPES=0,
    HTTP_WWW =1,
    HTTPS_WWW =2,
    HTTP =3,
    HTTPS =4,
    TEL = 5,
    MAILTO = 6,
    FTP_ANONYMOUS = 7,
    FTP_FTP = 8,
    FTPS =9,
    SFTP =10,
    SMB = 11,
    NFS =12,
    FTP=13,
    DAV=14,
    NEWS =15,
    TELNET =16,
    //.... TODO: list all types
    };

class UriNDEFRecord : public NDEFRecord{
    public:
        UriNDEFRecord(UriType, std::string);
        UriType getUriType();
        std::string getNDEFRecordHeader();
        static UriNDEFRecord* parseUriNDEFRecord(std::string,bool);
        NDEFRecordType getNDEFRecordType();
        std::string getPayload();
        std::string getPayloadHex();
    private:
        UriType uriType;
    
    
};


#endif